package Proyecto;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JColorChooser;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.UIManager;
import de.muntjak.tinylookandfeel.*;
import javax.swing.LookAndFeel;
import javax.swing.SwingUtilities;
import javax.swing.UnsupportedLookAndFeelException;

public class Principal extends javax.swing.JFrame implements KeyListener{

    //contructor:
    public Principal() {
        initComponents();
        setVentana();
    }
    
    //<editor-fold defaultstate="collapsed" desc="metodos">
    
    private void setVentana() {
        
        setLook();
        asignarEventoF1(this);
        this.help = new Gui_help();
        this.setLocationRelativeTo(null);
        this.setExtendedState(MAXIMIZED_BOTH);
        this.ta_general.setLineWrap(true);
        valoresPorDefecto();
        
    }
    
    private void setLook() {
        
        try {
            LookAndFeel look = new TinyLookAndFeel();
            int color = de.muntjak.tinylookandfeel.util.SBReference.BACK_COLOR;
            ThemeDescription[] theme = Theme.getAvailableThemes();
            Theme.loadTheme(theme[3]);//elegir tema
            
            UIManager.setLookAndFeel(new TinyLookAndFeel());
            SwingUtilities.updateComponentTreeUI(this);
            
            } catch (UnsupportedLookAndFeelException ex) {
            System.err.println("Errora al cargar el look and feel");
            Logger.getLogger(Principal.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    private void cargarTexto(File f) {
        this.ta_general.setText("");//reiniciar el text area
        
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new FileReader(f));
            
            String linea = reader.readLine();
            while (linea != null) {
                this.ta_general.append(linea +"\n");
                linea = reader.readLine();
            }
            
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Principal.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Principal.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            if(reader != null)try {
                reader.close();
            } catch (IOException ex) {
                Logger.getLogger(Principal.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        
    }
    
    private void asignarEventoF1(Container c) {
      
        Component[] comp = c.getComponents();
        for (Component component : comp) {
            if (component instanceof Container) {
                asignarEventoF1((Container)component);
            }
            component.addKeyListener(this);
        }
        
    }
    
    private void valoresPorDefecto() {
        
        this.ta_general.setText("");
        this.setTitle("Practica 3");
        this.lb_tamaño.setText("Tamaño:");
        this.m_editar.setEnabled(false);
        this.ta_general.setForeground(Color.WHITE);
        
    }

    private void cargarFile(File f) {
        
        this.setTitle(this.getTitle() + " - "+ f.getName());
        this.lb_tamaño.setText(lb_tamaño.getText()+ f.length()+" bytes");
        this.m_editar.setEnabled(true);
        
    }
    
    //</editor-fold>
    
    @SuppressWarnings("unchecked")
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lb_tamaño = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        ta_general = new javax.swing.JTextArea();
        jMenuBar1 = new javax.swing.JMenuBar();
        m_arch = new javax.swing.JMenu();
        mi_abrir = new javax.swing.JMenuItem();
        mi_cerrar = new javax.swing.JMenuItem();
        m_editar = new javax.swing.JMenu();
        Cambiarfuente = new javax.swing.JMenuItem();
        m_aplicacion = new javax.swing.JMenu();
        mi_ayuda = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        lb_tamaño.setText("Tamaño:");
        getContentPane().add(lb_tamaño, java.awt.BorderLayout.PAGE_END);

        ta_general.setEditable(false);
        ta_general.setColumns(20);
        ta_general.setRows(5);
        jScrollPane2.setViewportView(ta_general);

        getContentPane().add(jScrollPane2, java.awt.BorderLayout.CENTER);

        m_arch.setMnemonic('a');
        m_arch.setText("Archivo");

        mi_abrir.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.CTRL_MASK));
        mi_abrir.setText("Abrir");
        mi_abrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mi_abrirActionPerformed(evt);
            }
        });
        m_arch.add(mi_abrir);

        mi_cerrar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        mi_cerrar.setText("Cerrar");
        mi_cerrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mi_cerrarActionPerformed(evt);
            }
        });
        m_arch.add(mi_cerrar);

        jMenuBar1.add(m_arch);

        m_editar.setMnemonic('e');
        m_editar.setText("Editar");

        Cambiarfuente.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
        Cambiarfuente.setText("Cambiar fuente");
        Cambiarfuente.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CambiarfuenteActionPerformed(evt);
            }
        });
        m_editar.add(Cambiarfuente);

        jMenuBar1.add(m_editar);

        m_aplicacion.setText("Aplicacion");

        mi_ayuda.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Y, java.awt.event.InputEvent.CTRL_MASK));
        mi_ayuda.setText("Ayuda");
        mi_ayuda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mi_ayudaActionPerformed(evt);
            }
        });
        m_aplicacion.add(mi_ayuda);

        jMenuItem5.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem5.setText("Salir");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        m_aplicacion.add(jMenuItem5);

        jMenuBar1.add(m_aplicacion);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    //<editor-fold defaultstate="collapsed" desc="eventos">
    
    private void mi_cerrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mi_cerrarActionPerformed
        valoresPorDefecto();
    }//GEN-LAST:event_mi_cerrarActionPerformed

    private void CambiarfuenteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CambiarfuenteActionPerformed
    
        JColorChooser ch = new JColorChooser(this.ta_general.getForeground());
        JOptionPane.showMessageDialog(this, ch,"Seleciona color",JOptionPane.PLAIN_MESSAGE);
        if (!ch.getColor().equals(this.ta_general.getForeground())) {
            this.ta_general.setForeground(ch.getColor());
        }
        
    }//GEN-LAST:event_CambiarfuenteActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
       System.exit(0);
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void mi_abrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mi_abrirActionPerformed
       
        JFileChooser chooser = new JFileChooser(".");
        chooser.setFileFilter(new FileNameExtensionFilter("Fichero de texto plano (.txt)", "txt"));
        int resp = chooser.showOpenDialog(this);
        if (resp == JFileChooser.APPROVE_OPTION) {
            File sel = chooser.getSelectedFile();
            cargarTexto(sel);
            cargarFile(sel);
        }
        
    }//GEN-LAST:event_mi_abrirActionPerformed

    private void mi_ayudaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mi_ayudaActionPerformed
        help.setVisible(true);
    }//GEN-LAST:event_mi_ayudaActionPerformed

    //<editor-fold defaultstate="collapsed" desc="KeyEvents">

      @Override
    public void keyTyped(KeyEvent ke) {
    }

    @Override
    public void keyPressed(KeyEvent ke) {
        if (ke.getKeyCode() == KeyEvent.VK_F1) {
            this.help.setVisible(true);
        }
    }

    @Override
    public void keyReleased(KeyEvent ke) {
    }
    
    //</editor-fold>

    public static void main(String args[]) {
        
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Principal().setVisible(true);
            }
        });
    }

    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="atributos">
    
    Gui_help help;

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem Cambiarfuente;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lb_tamaño;
    private javax.swing.JMenu m_aplicacion;
    private javax.swing.JMenu m_arch;
    private javax.swing.JMenu m_editar;
    private javax.swing.JMenuItem mi_abrir;
    private javax.swing.JMenuItem mi_ayuda;
    private javax.swing.JMenuItem mi_cerrar;
    private javax.swing.JTextArea ta_general;
    // End of variables declaration//GEN-END:variables
    //</editor-fold>

}
